----------------------------------------------------------------------------------
-- SPI Interface, als schematic component in VHDL top level modul eingebunden.
-- Nov. 2007 A.Schnell  fr xc9572xl
-- Teilkomponenten ohne Simulation in Properties!
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity spi_s is
    Port ( RXin : in STD_LOGIC_VECTOR (0 to 7);
	        TXout : out STD_LOGIC_VECTOR (0 to 7);
	        MOSI : in  STD_LOGIC;
           MISO : out  STD_LOGIC;
           SLAVE_EN : in  STD_LOGIC;
           SCLK : in  STD_LOGIC );
end spi_s;


architecture Behavioral of spi_s is

  component parinoutshiftreg is
      port (  RXin0 : in STD_LOGIC;
		        RXin1 : in STD_LOGIC;
				  RXin2 : in STD_LOGIC;
				  RXin3 : in STD_LOGIC;
				  RXin4 : in STD_LOGIC;
				  RXin5 : in STD_LOGIC;
				  RXin6 : in STD_LOGIC;
				  RXin7 : in STD_LOGIC;
				  TXout0 : out STD_LOGIC;
				  TXout1 : out STD_LOGIC;
				  TXout2 : out STD_LOGIC;				  
				  TXout3 : out STD_LOGIC;				  
				  TXout4 : out STD_LOGIC;
				  TXout5 : out STD_LOGIC;
				  TXout6 : out STD_LOGIC;				  
				  TXout7 : out STD_LOGIC;
				  SS_Enable : in STD_LOGIC;
				  SIN : in STD_LOGIC;
				  SCLK : in STD_LOGIC;
				  SOUT0 : out STD_LOGIC;
				  SOUT : out STD_LOGIC);
	end component;
		
begin
 


		SHIFT: parinoutshiftreg  port map 
		     (  RXin0 => RXin(0),
		        RXin1 => RXin(1),
				  RXin2 => RXin(2),
				  RXin3 => RXin(3),
				  RXin4 => RXin(4),
				  RXin5 => RXin(5),
				  RXin6 => RXin(6),
				  RXin7 => RXin(7),
				  TXout0 => TXout(0),
				  TXout1 => TXout(1),
				  TXout2 => TXout(2),				  
				  TXout3 => TXout(3),				  
				  TXout4 => TXout(4),
				  TXout5 => TXout(5),
				  TXout6 => TXout(6),				  
				  TXout7 => TXout(7),
				  SS_Enable => SLAVE_EN,
				  SIN => MOSI,
				  SCLK => SCLK,
				  SOUT0 => MISO );


end Behavioral;

